/** @author abx
	This example shows that for reflections "super"
	doesn't mean much: for an object of class B which
	extends class A -- a.getClass() is the same class
	as is a.super.getClass(), it always returns the actual class.
	
	It also shows a difference between using instanceof and getClass()
    */

public class B extends A {
	
	@Override
	public String myClassName() {
		return "B" + ", son of " + super.myClassName();
	}
	
	// public String myParentClassName() {
	// 	//return super.getClass().getName();
	// 	return super.myClassName();
	// }
	
	public static void main(String... args) {
		A a;
		A b;
		
		b = new B();
		a = new A();
		
		System.out.print("The A's instance says: ");
		System.out.println("My class is " + a.myClassName());
		System.out.print("The B's instance says: ");
		System.out.println("My class is " + b.myClassName());
		// System.out.println(", and parent class is " + b.myParentClassName());
		System.out.println("-------------------------");
		System.out.println("Is a an instance of A? " + (a instanceof A));
		System.out.println("Is b an instance of A? " + (b instanceof A));
		System.out.println("Yet, the last question again: ");
		boolean answer = (b.getClass() == A.class); // use equals(), the result is the same!
		// boolean answer = (B.class == A.class);
		System.out.println("Is b an instance of A? " + answer);
		System.out.println("A is " + A.class);
		System.out.println("B is " + B.class);
	}
	
	private String sayIt(boolean b) {
		return b ? "Yes" : "No";
	}
}
